unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Spin;

type

  { TForm1 }

  TForm1 = class(TForm)
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Memo1: TMemo;
    SpinEdit1: TSpinEdit;
    procedure FormShow(Sender: TObject);
    procedure Memo1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure SpinEdit1Change(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  Memo1.Font.Height:=SpinEdit1.Value;
end;

procedure TForm1.Memo1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  vFontHeight, vScrollPos, vSelectedLine, vLinePos, vLineLength: Integer;
  bmp: TBitmap;
begin

  // Fontgröße
  bmp := TBitmap.Create;
  try
    bmp.Canvas.Font.Assign(Memo1.Font);
    vFontHeight := bmp.Canvas.TextHeight(Memo1.Text);
  finally
    bmp.Free;
  end;

  // Position der Vertikalen Scrollbar als "Offset"
  vScrollPos    := Memo1.VertScrollBar.Position;

  // Selektierte Zeile (Y Pixel der Maus / Fontgröße) + Scroll Offset
  vSelectedLine := ( Y div vFontHeight ) + vScrollPos;

  { !!! ACHTUNG !!!
   Das hat einen Nachteil, wenn der selbe Text mehrfach vorkommt
   dann springt die Selektion wieder an das erste vorkommen im Memo. }
  // Position des selktierten Textes
  vLinePos  := Pos(Memo1.Lines[vSelectedLine], Memo1.Text);

  // Länge des Textes wo die Maus ist
  vLineLength := Length(Memo1.Lines[vSelectedLine]);

  //
  Memo1.SetFocus;
  Memo1.SelStart := vLinePos - 1;
  Memo1.SelLength := vLineLength;


  // Debug
  Label8.Caption  := ': ' + IntToStr(vFontHeight);
  Label9.Caption  := ': ' + Y.ToString;
  Label10.Caption := ': ' + IntToStr(vSelectedLine);
  Label11.Caption := ': ' + Memo1.VertScrollBar.Position.ToString;
  Label12.Caption := ': ' + Memo1.Lines[vSelectedLine];
  Label13.Caption := ': ' + IntToStr(vLinePos - 1) + ', Length: '+ IntToStr(vLineLength);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Memo1.Font.Height = 0 then
    SpinEdit1.Value := 16
  else
    SpinEdit1.Value := Memo1.Font.Height;
end;

end.

